diff --git a/src/backend/catalog/system_views.sql b/src/backend/catalog/system_views.sql
index 4427b2232b0..e49ff9c049d 100644
--- a/src/backend/catalog/system_views.sql
+++ b/src/backend/catalog/system_views.sql
@@ -1472,25 +1472,6 @@ CREATE VIEW pg_stat_progress_copy AS
     FROM pg_stat_get_progress_info('COPY') AS S
         LEFT JOIN pg_database D ON S.datid = D.oid;
 
-CREATE VIEW pg_stat_progress_data_checksums AS
-    SELECT
-        S.pid AS pid, S.datid, D.datname AS datname,
-        CASE S.param1 WHEN 0 THEN 'enabling'
-                      WHEN 1 THEN 'disabling'
-                      WHEN 2 THEN 'waiting on temporary tables'
-					  WHEN 3 THEN 'waiting on barrier'
-                      WHEN 4 THEN 'done'
-                      END AS phase,
-        CASE S.param2 WHEN -1 THEN NULL ELSE S.param2 END AS databases_total,
-        CASE S.param3 WHEN -1 THEN NULL ELSE S.param3 END AS databases_done,
-        CASE S.param4 WHEN -1 THEN NULL ELSE S.param4 END AS relations_total,
-        CASE S.param5 WHEN -1 THEN NULL ELSE S.param5 END AS relations_done,
-        CASE S.param6 WHEN -1 THEN NULL ELSE S.param6 END AS blocks_total,
-        CASE S.param7 WHEN -1 THEN NULL ELSE S.param7 END AS blocks_done
-    FROM pg_stat_get_progress_info('DATACHECKSUMS') AS S
-        LEFT JOIN pg_database D ON S.datid = D.oid
-    ORDER BY S.datid; -- return the launcher process first
-
 CREATE VIEW pg_user_mappings AS
     SELECT
         U.oid       AS umid,
diff --git a/src/backend/commands/dbcommands.c b/src/backend/commands/dbcommands.c
index 600fc742a68..5ca1a299efd 100644
--- a/src/backend/commands/dbcommands.c
+++ b/src/backend/commands/dbcommands.c
@@ -559,23 +559,6 @@ CreateDatabaseUsingFileCopy(Oid src_dboid, Oid dst_dboid, Oid src_tsid,
 	Relation	rel;
 	HeapTuple	tuple;
 
-	/*
-	 * The strategy check in createdb() runs before our transaction has an XID
-	 * and before the pg_database row exists, so the datachecksumsworker
-	 * launcher can start in that window and miss both the new database and
-	 * our transaction, leaving the raw-copied files without checksums.
-	 */
-	if (DataChecksumsInProgressOn())
-		ereport(ERROR,
-				errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
-				errmsg("create database strategy \"%s\" not allowed when data checksums are being enabled",
-					   "file_copy"));
-
-	/*
-	 * The XID is assigned by now, so a datachecksumsworker launcher starting
-	 * after this point will wait for us and find the new database.
-	 */
-
 	/*
 	 * Force a checkpoint before starting the copy. This will force all dirty
 	 * buffers, including those of unlogged tables, out to disk, to ensure
@@ -1062,22 +1045,7 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 		if (pg_strcasecmp(strategy, "wal_log") == 0)
 			dbstrategy = CREATEDB_WAL_LOG;
 		else if (pg_strcasecmp(strategy, "file_copy") == 0)
-		{
-			/*
-			 * If data checksums are being enabled we must not use file_copy
-			 * since it might copy source database which hasn't yet had data
-			 * checksums enabled, and the destination database will be skipped
-			 * as it's expected to have data checksums enabled.  Once we have
-			 * an XID assigned this needs to be rechecked, but if can error
-			 * out already we can save a lot of work.
-			 */
-			if (DataChecksumsInProgressOn())
-				ereport(ERROR,
-						errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-						errmsg("create database strategy \"%s\" not allowed when data checksums are being enabled",
-							   strategy));
 			dbstrategy = CREATEDB_FILE_COPY;
-		}
 		else
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
@@ -1883,8 +1851,6 @@ dropdb(const char *dbname, bool missing_ok, bool force)
 	systable_inplace_update_finish(inplace_state, tup);
 	XLogFlush(XactLastRecEnd);
 
-	INJECTION_POINT("dropdb-after-invalid-marker", NULL);
-
 	/*
 	 * Also delete the tuple - transactionally. If this transaction commits,
 	 * the row will be gone, but if we fail, dropdb() can be invoked again.
diff --git a/src/backend/postmaster/Makefile b/src/backend/postmaster/Makefile
index 55044b2bc6f..0f4435d2d97 100644
--- a/src/backend/postmaster/Makefile
+++ b/src/backend/postmaster/Makefile
@@ -18,7 +18,6 @@ OBJS = \
 	bgworker.o \
 	bgwriter.o \
 	checkpointer.o \
-	datachecksum_state.o \
 	fork_process.o \
 	interrupt.o \
 	launch_backend.o \
diff --git a/src/backend/postmaster/auxprocess.c b/src/backend/postmaster/auxprocess.c
index ad4bf4bd2a8..2b8f45f0390 100644
--- a/src/backend/postmaster/auxprocess.c
+++ b/src/backend/postmaster/auxprocess.c
@@ -68,36 +68,8 @@ AuxiliaryProcessMainCommon(void)
 
 	BaseInit();
 
-	/*
-	 * Prevent consuming interrupts between setting ProcSignalInit and setting
-	 * the initial local data checksum value.  If a barrier is emitted, and
-	 * absorbed, before local cached state is initialized the state transition
-	 * can be invalid.
-	 */
-	HOLD_INTERRUPTS();
-
 	ProcSignalInit(NULL, 0);
 
-	/*
-	 * Initialize a local cache of the data_checksum_version, to be updated by
-	 * the procsignal-based barriers.
-	 *
-	 * This intentionally happens after initializing the procsignal, otherwise
-	 * we might miss a state change. This means we can get a barrier for the
-	 * state we've just initialized - but it can happen only once.
-	 *
-	 * The postmaster (which is what gets forked into the new child process)
-	 * does not handle barriers, therefore it may not have the current value
-	 * of LocalDataChecksumState value (it'll have the value read from the
-	 * control file, which may be arbitrarily old).
-	 *
-	 * NB: Even if the postmaster handled barriers, the value might still be
-	 * stale, as it might have changed after this process forked.
-	 */
-	InitLocalDataChecksumState();
-
-	RESUME_INTERRUPTS();
-
 	/*
 	 * Initialize the process-local logical info WAL logging state.
 	 *
diff --git a/src/backend/postmaster/bgworker.c b/src/backend/postmaster/bgworker.c
index 4627f99dafb..884c0e76d8d 100644
--- a/src/backend/postmaster/bgworker.c
+++ b/src/backend/postmaster/bgworker.c
@@ -19,7 +19,6 @@
 #include "pgstat.h"
 #include "port/atomics.h"
 #include "postmaster/bgworker_internals.h"
-#include "postmaster/datachecksum_state.h"
 #include "postmaster/postmaster.h"
 #include "replication/logicallauncher.h"
 #include "replication/logicalworker.h"
@@ -158,14 +157,6 @@ static const struct
 	{
 		.fn_name = "TableSyncWorkerMain",
 		.fn_addr = TableSyncWorkerMain
-	},
-	{
-		.fn_name = "DataChecksumsWorkerLauncherMain",
-		.fn_addr = DataChecksumsWorkerLauncherMain
-	},
-	{
-		.fn_name = "DataChecksumsWorkerMain",
-		.fn_addr = DataChecksumsWorkerMain
 	}
 };
 
diff --git a/src/backend/postmaster/meson.build b/src/backend/postmaster/meson.build
index 6cba23bbeef..e1f70726604 100644
--- a/src/backend/postmaster/meson.build
+++ b/src/backend/postmaster/meson.build
@@ -6,7 +6,6 @@ backend_sources += files(
   'bgworker.c',
   'bgwriter.c',
   'checkpointer.c',
-  'datachecksum_state.c',
   'fork_process.c',
   'interrupt.c',
   'launch_backend.c',
diff --git a/src/backend/postmaster/postmaster.c b/src/backend/postmaster/postmaster.c
index c5b141ed3e3..2ba40fde67b 100644
--- a/src/backend/postmaster/postmaster.c
+++ b/src/backend/postmaster/postmaster.c
@@ -3024,11 +3024,6 @@ PostmasterStateMachine(void)
 									B_INVALID,
 									B_STANDALONE_BACKEND);
 
-			/* also add data checksums processes */
-			remainMask = btmask_add(remainMask,
-									B_DATACHECKSUMSWORKER_LAUNCHER,
-									B_DATACHECKSUMSWORKER_WORKER);
-
 			/* All types should be included in targetMask or remainMask */
 			Assert((remainMask.mask | targetMask.mask) == BTYPE_MASK_ALL.mask);
 		}
diff --git a/src/backend/replication/logical/decode.c b/src/backend/replication/logical/decode.c
index c944be4ac83..570b0e9d285 100644
--- a/src/backend/replication/logical/decode.c
+++ b/src/backend/replication/logical/decode.c
@@ -190,22 +190,6 @@ xlog_decode(LogicalDecodingContext *ctx, XLogRecordBuffer *buf)
 	}
 }
 
-void
-xlog2_decode(LogicalDecodingContext *ctx, XLogRecordBuffer *buf)
-{
-	uint8		info = XLogRecGetInfo(buf->record) & ~XLR_INFO_MASK;
-
-	ReorderBufferProcessXid(ctx->reorder, XLogRecGetXid(buf->record), buf->origptr);
-
-	switch (info)
-	{
-		case XLOG2_CHECKSUMS:
-			break;
-		default:
-			elog(ERROR, "unexpected RM_XLOG2_ID record type: %u", info);
-	}
-}
-
 /*
  * Handle rmgr XACT_ID records for LogicalDecodingProcessRecord().
  */
diff --git a/src/backend/storage/ipc/procsignal.c b/src/backend/storage/ipc/procsignal.c
index 1397f65f67b..f8091d83099 100644
--- a/src/backend/storage/ipc/procsignal.c
+++ b/src/backend/storage/ipc/procsignal.c
@@ -23,7 +23,6 @@
 #include "miscadmin.h"
 #include "pgstat.h"
 #include "port/pg_bitutils.h"
-#include "postmaster/datachecksum_state.h"
 #include "replication/logicalctl.h"
 #include "replication/logicalworker.h"
 #include "replication/slotsync.h"
@@ -591,13 +590,6 @@ ProcessProcSignalBarrier(void)
 					case PROCSIGNAL_BARRIER_UPDATE_XLOG_LOGICAL_INFO:
 						processed = ProcessBarrierUpdateXLogLogicalInfo();
 						break;
-
-					case PROCSIGNAL_BARRIER_CHECKSUM_INPROGRESS_ON:
-					case PROCSIGNAL_BARRIER_CHECKSUM_ON:
-					case PROCSIGNAL_BARRIER_CHECKSUM_INPROGRESS_OFF:
-					case PROCSIGNAL_BARRIER_CHECKSUM_OFF:
-						processed = AbsorbDataChecksumsBarrier(type);
-						break;
 				}
 
 				/*
diff --git a/src/backend/storage/page/README b/src/backend/storage/page/README
index 73c36a63908..e30d7ac59ad 100644
--- a/src/backend/storage/page/README
+++ b/src/backend/storage/page/README
@@ -10,9 +10,7 @@ http://www.cs.toronto.edu/~bianca/papers/sigmetrics09.pdf, discussed
 2010/12/22 on -hackers list.
 
 Current implementation requires this be enabled system-wide at initdb time, or
-by using the pg_checksums tool on an offline cluster.  Checksums can also be
-enabled at runtime using pg_enable_data_checksums(), and disabled by using
-pg_disable_data_checksums().
+by using the pg_checksums tool on an offline cluster.
 
 The checksum is not valid at all times on a data page!!
 The checksum is valid when the page leaves the shared pool and is checked
diff --git a/src/backend/storage/page/bufpage.c b/src/backend/storage/page/bufpage.c
index 8df74618fcd..3b429048436 100644
--- a/src/backend/storage/page/bufpage.c
+++ b/src/backend/storage/page/bufpage.c
@@ -107,15 +107,7 @@ PageIsVerified(PageData *page, BlockNumber blkno, int flags, bool *checksum_fail
 	 */
 	if (!PageIsNew(page))
 	{
-		/*
-		 * There shouldn't be any check for interrupt calls happening in this
-		 * codepath, but just to be on the safe side we hold interrupts since
-		 * if they did happen the data checksum state could change during
-		 * verifying checksums, which could lead to incorrect verification
-		 * results.
-		 */
-		HOLD_INTERRUPTS();
-		if (DataChecksumsNeedVerify())
+		if (DataChecksumsEnabled())
 		{
 			checksum = pg_checksum_page(page, blkno);
 
@@ -126,7 +118,6 @@ PageIsVerified(PageData *page, BlockNumber blkno, int flags, bool *checksum_fail
 					*checksum_failure_p = true;
 			}
 		}
-		RESUME_INTERRUPTS();
 
 		/*
 		 * The following checks don't prove the header is correct, only that
@@ -1519,14 +1510,9 @@ PageIndexTupleOverwrite(Page page, OffsetNumber offnum,
 void
 PageSetChecksum(Page page, BlockNumber blkno)
 {
-	HOLD_INTERRUPTS();
 	/* If we don't need a checksum, just return */
-	if (PageIsNew(page) || !DataChecksumsNeedWrite())
-	{
-		RESUME_INTERRUPTS();
+	if (PageIsNew(page) || !DataChecksumsEnabled())
 		return;
-	}
 
 	((PageHeader) page)->pd_checksum = pg_checksum_page(page, blkno);
-	RESUME_INTERRUPTS();
 }
diff --git a/src/backend/utils/activity/pgstat_backend.c b/src/backend/utils/activity/pgstat_backend.c
index 73461c9bca5..c5fecbf577c 100644
--- a/src/backend/utils/activity/pgstat_backend.c
+++ b/src/backend/utils/activity/pgstat_backend.c
@@ -381,8 +381,6 @@ pgstat_tracks_backend_bktype(BackendType bktype)
 		case B_CHECKPOINTER:
 		case B_IO_WORKER:
 		case B_STARTUP:
-		case B_DATACHECKSUMSWORKER_LAUNCHER:
-		case B_DATACHECKSUMSWORKER_WORKER:
 			return false;
 
 		case B_AUTOVAC_WORKER:
diff --git a/src/backend/utils/activity/pgstat_io.c b/src/backend/utils/activity/pgstat_io.c
index 8ec1aad5078..ae52baafd11 100644
--- a/src/backend/utils/activity/pgstat_io.c
+++ b/src/backend/utils/activity/pgstat_io.c
@@ -354,8 +354,6 @@ pgstat_tracks_io_bktype(BackendType bktype)
 		case B_LOGGER:
 			return false;
 
-		case B_DATACHECKSUMSWORKER_LAUNCHER:
-		case B_DATACHECKSUMSWORKER_WORKER:
 		case B_AUTOVAC_LAUNCHER:
 		case B_AUTOVAC_WORKER:
 		case B_BACKEND:
@@ -456,37 +454,6 @@ pgstat_tracks_io_object(BackendType bktype, IOObject io_object,
 		io_context == IOCONTEXT_BULKWRITE)
 		return false;
 
-	/*
-	 * The data checksums launcher scans catalogs and emits WAL records for
-	 * checksum state changes. Catalog scans can use a bulkread strategy.
-	 */
-	if (bktype == B_DATACHECKSUMSWORKER_LAUNCHER)
-	{
-		if (io_object == IOOBJECT_WAL ||
-			(io_object == IOOBJECT_RELATION &&
-			 (io_context == IOCONTEXT_BULKREAD ||
-			  io_context == IOCONTEXT_NORMAL)))
-			return true;
-
-		return false;
-	}
-
-	/*
-	 * The worker also scans catalogs, then processes relations using a vacuum
-	 * access strategy. Catalog scans can use a bulkread strategy.
-	 */
-	if (bktype == B_DATACHECKSUMSWORKER_WORKER)
-	{
-		if (io_object == IOOBJECT_WAL ||
-			(io_object == IOOBJECT_RELATION &&
-			 (io_context == IOCONTEXT_BULKREAD ||
-			  io_context == IOCONTEXT_NORMAL ||
-			  io_context == IOCONTEXT_VACUUM)))
-			return true;
-
-		return false;
-	}
-
 	return true;
 }
 
@@ -530,8 +497,6 @@ pgstat_tracks_io_op(BackendType bktype, IOObject io_object,
 	if (io_object == IOOBJECT_WAL && io_op == IOOP_READ &&
 		(bktype == B_WAL_RECEIVER || bktype == B_BG_WRITER ||
 		 bktype == B_AUTOVAC_LAUNCHER || bktype == B_AUTOVAC_WORKER ||
-		 bktype == B_DATACHECKSUMSWORKER_LAUNCHER ||
-		 bktype == B_DATACHECKSUMSWORKER_WORKER ||
 		 bktype == B_WAL_WRITER))
 		return false;
 
diff --git a/src/backend/utils/adt/pgstatfuncs.c b/src/backend/utils/adt/pgstatfuncs.c
index 0c59df17901..fce3b4f4088 100644
--- a/src/backend/utils/adt/pgstatfuncs.c
+++ b/src/backend/utils/adt/pgstatfuncs.c
@@ -297,8 +297,6 @@ pg_stat_get_progress_info(PG_FUNCTION_ARGS)
 		cmdtype = PROGRESS_COMMAND_BASEBACKUP;
 	else if (pg_strcasecmp(cmd, "COPY") == 0)
 		cmdtype = PROGRESS_COMMAND_COPY;
-	else if (pg_strcasecmp(cmd, "DATACHECKSUMS") == 0)
-		cmdtype = PROGRESS_COMMAND_DATACHECKSUMS;
 	else
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
@@ -1184,6 +1182,9 @@ pg_stat_get_db_checksum_failures(PG_FUNCTION_ARGS)
 	int64		result;
 	PgStat_StatDBEntry *dbentry;
 
+	if (!DataChecksumsEnabled())
+		PG_RETURN_NULL();
+
 	if ((dbentry = pgstat_fetch_stat_dbentry(dbid)) == NULL)
 		result = 0;
 	else
@@ -1199,6 +1200,9 @@ pg_stat_get_db_checksum_last_failure(PG_FUNCTION_ARGS)
 	TimestampTz result;
 	PgStat_StatDBEntry *dbentry;
 
+	if (!DataChecksumsEnabled())
+		PG_RETURN_NULL();
+
 	if ((dbentry = pgstat_fetch_stat_dbentry(dbid)) == NULL)
 		result = 0;
 	else
diff --git a/src/backend/utils/init/miscinit.c b/src/backend/utils/init/miscinit.c
index 7ffc808073a..ba191977697 100644
--- a/src/backend/utils/init/miscinit.c
+++ b/src/backend/utils/init/miscinit.c
@@ -845,8 +845,7 @@ InitializeSessionUserIdStandalone(void)
 	 * workers, in slot sync worker and in background workers.
 	 */
 	Assert(!IsUnderPostmaster || AmAutoVacuumWorkerProcess() ||
-		   AmLogicalSlotSyncWorkerProcess() || AmBackgroundWorkerProcess() ||
-		   AmDataChecksumsWorkerProcess());
+		   AmLogicalSlotSyncWorkerProcess() || AmBackgroundWorkerProcess());
 
 	/* call only once */
 	Assert(!OidIsValid(AuthenticatedUserId));
diff --git a/src/backend/utils/init/postinit.c b/src/backend/utils/init/postinit.c
index 3d8c9bdebd5..ebbcfc62a4d 100644
--- a/src/backend/utils/init/postinit.c
+++ b/src/backend/utils/init/postinit.c
@@ -759,36 +759,8 @@ InitPostgres(const char *in_dbname, Oid dboid,
 	 */
 	SharedInvalBackendInit(false);
 
-	/*
-	 * Prevent consuming interrupts between setting ProcSignalInit and setting
-	 * the initial local data checksum value.  If a barrier is emitted, and
-	 * absorbed, before local cached state is initialized the state transition
-	 * can be invalid.
-	 */
-	HOLD_INTERRUPTS();
-
 	ProcSignalInit(MyCancelKey, MyCancelKeyLength);
 
-	/*
-	 * Initialize a local cache of the data_checksum_version, to be updated by
-	 * the procsignal-based barriers.
-	 *
-	 * This intentionally happens after initializing the procsignal, otherwise
-	 * we might miss a state change. This means we can get a barrier for the
-	 * state we've just initialized.
-	 *
-	 * The postmaster (which is what gets forked into the new child process)
-	 * does not handle barriers, therefore it may not have the current value
-	 * of LocalDataChecksumState value (it'll have the value read from the
-	 * control file, which may be arbitrarily old).
-	 *
-	 * NB: Even if the postmaster handled barriers, the value might still be
-	 * stale, as it might have changed after this process forked.
-	 */
-	InitLocalDataChecksumState();
-
-	RESUME_INTERRUPTS();
-
 	/*
 	 * Also set up timeout handlers needed for backend operation.  We need
 	 * these in every case except bootstrap.
@@ -927,7 +899,7 @@ InitPostgres(const char *in_dbname, Oid dboid,
 					 errhint("You should immediately run CREATE USER \"%s\" SUPERUSER;.",
 							 username != NULL ? username : "postgres")));
 	}
-	else if (AmBackgroundWorkerProcess() || AmDataChecksumsWorkerProcess())
+	else if (AmBackgroundWorkerProcess())
 	{
 		if (username == NULL && !OidIsValid(useroid))
 		{
diff --git a/src/backend/utils/misc/guc_tables.c b/src/backend/utils/misc/guc_tables.c
index 031dd60771e..463ca1967fd 100644
--- a/src/backend/utils/misc/guc_tables.c
+++ b/src/backend/utils/misc/guc_tables.c
@@ -512,14 +512,6 @@ static const struct config_enum_entry file_extend_method_options[] = {
 	{NULL, 0, false}
 };
 
-static const struct config_enum_entry data_checksums_options[] = {
-	{"on", PG_DATA_CHECKSUM_VERSION, true},
-	{"off", PG_DATA_CHECKSUM_OFF, true},
-	{"inprogress-on", PG_DATA_CHECKSUM_INPROGRESS_ON, true},
-	{"inprogress-off", PG_DATA_CHECKSUM_INPROGRESS_OFF, true},
-	{NULL, 0, false}
-};
-
 /*
  * Options for enum values stored in other modules
  */
@@ -648,6 +640,7 @@ static int	shared_memory_size_in_huge_pages;
 static int	wal_block_size;
 static int	num_os_semaphores;
 static int	effective_wal_level = WAL_LEVEL_REPLICA;
+static bool data_checksums;
 static bool integer_datetimes;
 
 #ifdef USE_ASSERT_CHECKING
diff --git a/src/backend/utils/misc/pg_controldata.c b/src/backend/utils/misc/pg_controldata.c
index 9014f0953e9..82ac9fc4537 100644
--- a/src/backend/utils/misc/pg_controldata.c
+++ b/src/backend/utils/misc/pg_controldata.c
@@ -69,8 +69,8 @@ pg_control_system(PG_FUNCTION_ARGS)
 Datum
 pg_control_checkpoint(PG_FUNCTION_ARGS)
 {
-	Datum		values[20];
-	bool		nulls[20];
+	Datum		values[19];
+	bool		nulls[19];
 	TupleDesc	tupdesc;
 	HeapTuple	htup;
 	ControlFileData *ControlFile;
@@ -154,12 +154,9 @@ pg_control_checkpoint(PG_FUNCTION_ARGS)
 	values[17] = TransactionIdGetDatum(ControlFile->checkPointCopy.newestCommitTsXid);
 	nulls[17] = false;
 
-	values[18] = Int32GetDatum(ControlFile->checkPointCopy.dataChecksumState);
+	values[18] = TimestampTzGetDatum(time_t_to_timestamptz(ControlFile->checkPointCopy.time));
 	nulls[18] = false;
 
-	values[19] = TimestampTzGetDatum(time_t_to_timestamptz(ControlFile->checkPointCopy.time));
-	nulls[19] = false;
-
 	htup = heap_form_tuple(tupdesc, values, nulls);
 
 	PG_RETURN_DATUM(HeapTupleGetDatum(htup));
diff --git a/src/backend/utils/misc/postgresql.conf.sample b/src/backend/utils/misc/postgresql.conf.sample
index 5538ad558c7..5218395f98a 100644
--- a/src/backend/utils/misc/postgresql.conf.sample
+++ b/src/backend/utils/misc/postgresql.conf.sample
@@ -557,11 +557,11 @@
                                         # archiver              autovacuum
                                         # backend               bgworker
                                         # bgwriter              checkpointer
-                                        # checksums             ioworker
-                                        # postmaster            slotsyncworker
-                                        # startup               syslogger
-                                        # walreceiver           walsummarizer
-                                        # walwriter             walsender
+                                        # ioworker              postmaster
+                                        # slotsyncworker        startup
+                                        # syslogger             walreceiver
+                                        # walsummarizer         walwriter
+                                        # walsender
                                         #
                                         # Level values in order of decreasing
                                         # detail:
diff --git a/src/bin/pg_checksums/t/002_actions.pl b/src/bin/pg_checksums/t/002_actions.pl
index 94a11a534e9..dc91e70acf0 100644
--- a/src/bin/pg_checksums/t/002_actions.pl
+++ b/src/bin/pg_checksums/t/002_actions.pl
@@ -216,6 +216,11 @@ $node->start;
 command_fails([ 'pg_checksums', '--check', '--pgdata' => $pgdata ],
 	"fails with online cluster");
 
+# Make sure pg_control_init reports the initial state as disabled
+my $result = $node->safe_psql('postgres',
+	'SELECT data_page_checksum_version FROM pg_control_init();');
+is($result, '0', 'ensure pg_control_init reports disabled state');
+
 # Check corruption of table on default tablespace.
 check_relation_corruption($node, 'corrupt1', 'pg_default');
 
diff --git a/src/bin/pg_controldata/pg_controldata.c b/src/bin/pg_controldata/pg_controldata.c
index 6fc87ed114d..bd709a5c1d9 100644
--- a/src/bin/pg_controldata/pg_controldata.c
+++ b/src/bin/pg_controldata/pg_controldata.c
@@ -289,8 +289,6 @@ main(int argc, char *argv[])
 		   ControlFile->checkPointCopy.oldestCommitTsXid);
 	printf(_("Latest checkpoint's newestCommitTsXid:%u\n"),
 		   ControlFile->checkPointCopy.newestCommitTsXid);
-	printf(_("Latest checkpoint's data_checksum_version:%u\n"),
-		   ControlFile->checkPointCopy.dataChecksumState);
 	printf(_("Time of latest checkpoint:            %s\n"),
 		   ckpttime_str);
 	printf(_("Fake LSN counter for unlogged rels:   %X/%08X\n"),
diff --git a/src/bin/pg_upgrade/controldata.c b/src/bin/pg_upgrade/controldata.c
index 8c69329805b..6abc2c0096a 100644
--- a/src/bin/pg_upgrade/controldata.c
+++ b/src/bin/pg_upgrade/controldata.c
@@ -15,7 +15,6 @@
 #include "access/xlog_internal.h"
 #include "common/string.h"
 #include "pg_upgrade.h"
-#include "storage/checksum.h"
 
 
 /*
@@ -737,14 +736,6 @@ check_control_data(ControlData *oldctrl,
 	 * check_for_isn_and_int8_passing_mismatch().
 	 */
 
-	/*
-	 * If data checksums are in any in-progress state then disallow the
-	 * upgrade. The user should either let the process finish, or turn off
-	 * data checksums, before retrying.
-	 */
-	if (oldctrl->data_checksum_version > PG_DATA_CHECKSUM_VERSION)
-		pg_fatal("data checksums are being enabled in the old cluster");
-
 	/*
 	 * We might eventually allow upgrades from checksum to no-checksum
 	 * clusters.
diff --git a/src/bin/pg_waldump/t/001_basic.pl b/src/bin/pg_waldump/t/001_basic.pl
index 53b2f016b80..c9d72326f0f 100644
--- a/src/bin/pg_waldump/t/001_basic.pl
+++ b/src/bin/pg_waldump/t/001_basic.pl
@@ -79,8 +79,7 @@ BRIN
 CommitTs
 ReplicationOrigin
 Generic
-LogicalMessage
-XLOG2$/,
+LogicalMessage$/,
 	'rmgr list');
 
 
diff --git a/src/include/access/rmgrlist.h b/src/include/access/rmgrlist.h
index ae32ef16d67..3352b5f8532 100644
--- a/src/include/access/rmgrlist.h
+++ b/src/include/access/rmgrlist.h
@@ -47,4 +47,3 @@ PG_RMGR(RM_COMMIT_TS_ID, "CommitTs", commit_ts_redo, commit_ts_desc, commit_ts_i
 PG_RMGR(RM_REPLORIGIN_ID, "ReplicationOrigin", replorigin_redo, replorigin_desc, replorigin_identify, NULL, NULL, NULL, NULL)
 PG_RMGR(RM_GENERIC_ID, "Generic", generic_redo, generic_desc, generic_identify, NULL, NULL, generic_mask, NULL)
 PG_RMGR(RM_LOGICALMSG_ID, "LogicalMessage", logicalmsg_redo, logicalmsg_desc, logicalmsg_identify, NULL, NULL, NULL, logicalmsg_decode)
-PG_RMGR(RM_XLOG2_ID, "XLOG2", xlog2_redo, xlog2_desc, xlog2_identify, NULL, NULL, NULL, xlog2_decode)
diff --git a/src/include/access/xlog.h b/src/include/access/xlog.h
index 130ba929109..d81ede22224 100644
--- a/src/include/access/xlog.h
+++ b/src/include/access/xlog.h
@@ -57,7 +57,6 @@ extern PGDLLIMPORT int CommitDelay;
 extern PGDLLIMPORT int CommitSiblings;
 extern PGDLLIMPORT bool track_wal_io_timing;
 extern PGDLLIMPORT int wal_decode_buffer_size;
-extern PGDLLIMPORT int data_checksums;
 
 extern PGDLLIMPORT int CheckPointSegments;
 
@@ -133,7 +132,7 @@ extern PGDLLIMPORT bool XLogLogicalInfo;
  * of the bits make it to disk, but the checksum wouldn't match.  Also WAL-log
  * them if forced by wal_log_hints=on.
  */
-#define XLogHintBitIsNeeded() (wal_log_hints || DataChecksumsNeedWrite())
+#define XLogHintBitIsNeeded() (wal_log_hints || DataChecksumsEnabled())
 
 /* Do we need to WAL-log information required only for Hot Standby and logical replication? */
 #define XLogStandbyInfoActive() (wal_level >= WAL_LEVEL_REPLICA)
@@ -243,11 +242,8 @@ extern void XLogSetReplicationSlotMinimumLSN(XLogRecPtr lsn);
 extern XLogRecPtr XLogGetReplicationSlotMinimumLSN(void);
 
 extern void xlog_redo(struct XLogReaderState *record);
-extern void xlog2_redo(struct XLogReaderState *record);
 extern void xlog_desc(StringInfo buf, struct XLogReaderState *record);
-extern void xlog2_desc(StringInfo buf, struct XLogReaderState *record);
 extern const char *xlog_identify(uint8 info);
-extern const char *xlog2_identify(uint8 info);
 
 extern void issue_xlog_fsync(int fd, XLogSegNo segno, TimeLineID tli);
 
@@ -260,19 +256,7 @@ extern XLogRecPtr GetXLogWriteRecPtr(void);
 
 extern uint64 GetSystemIdentifier(void);
 extern char *GetMockAuthenticationNonce(void);
-extern bool DataChecksumsNeedWrite(void);
-extern bool DataChecksumsNeedVerify(void);
-extern XLogRecPtr GetLastChecksumChangeRecPtr(void);
-extern bool DataChecksumsOn(void);
-extern bool DataChecksumsOff(void);
-extern bool DataChecksumsInProgressOn(void);
-extern void SetDataChecksumsOnInProgress(void);
-extern void SetDataChecksumsOn(void);
-extern void SetDataChecksumsOff(void);
-extern const char *show_data_checksums(void);
-extern const char *get_checksum_state_string(uint32 state);
-extern void InitLocalDataChecksumState(void);
-extern void SetLocalDataChecksumState(uint32 data_checksum_version);
+extern bool DataChecksumsEnabled(void);
 extern bool GetDefaultCharSignedness(void);
 extern XLogRecPtr GetFakeLSNForUnloggedRel(void);
 extern void BootStrapXLOG(uint32 data_checksum_version);
diff --git a/src/include/access/xlog_internal.h b/src/include/access/xlog_internal.h
index be718993401..3a2fd9d160e 100644
--- a/src/include/access/xlog_internal.h
+++ b/src/include/access/xlog_internal.h
@@ -288,12 +288,6 @@ typedef struct xl_restore_point
 	char		rp_name[MAXFNAMELEN];
 } xl_restore_point;
 
-/* Information logged when data checksum level is changed */
-typedef struct xl_checksum_state
-{
-	ChecksumStateType new_checksum_state;
-} xl_checksum_state;
-
 /* Overwrite of prior contrecord */
 typedef struct xl_overwrite_contrecord
 {
diff --git a/src/include/catalog/pg_control.h b/src/include/catalog/pg_control.h
index 7b5404460ec..b875c5c0e3a 100644
--- a/src/include/catalog/pg_control.h
+++ b/src/include/catalog/pg_control.h
@@ -63,9 +63,6 @@ typedef struct CheckPoint
 	 * set to InvalidTransactionId.
 	 */
 	TransactionId oldestActiveXid;
-
-	/* data checksums state at the time of the checkpoint  */
-	uint32		dataChecksumState;
 } CheckPoint;
 
 /* XLOG info values for XLOG rmgr */
@@ -86,10 +83,6 @@ typedef struct CheckPoint
 #define XLOG_CHECKPOINT_REDO			0xE0
 #define XLOG_LOGICAL_DECODING_STATUS_CHANGE	0xF0
 
-/* XLOG info values for XLOG2 rmgr */
-#define XLOG2_CHECKSUMS					0x00
-
-
 /*
  * System status indicator.  Note this is stored in pg_control; if you change
  * it, you must bump PG_CONTROL_VERSION
diff --git a/src/include/commands/progress.h b/src/include/commands/progress.h
index 2a12920c75f..b5b01c1bb6d 100644
--- a/src/include/commands/progress.h
+++ b/src/include/commands/progress.h
@@ -188,20 +188,4 @@
 #define PROGRESS_COPY_TYPE_PIPE 3
 #define PROGRESS_COPY_TYPE_CALLBACK 4
 
-/* Progress parameters for PROGRESS_DATACHECKSUMS */
-#define PROGRESS_DATACHECKSUMS_PHASE		0
-#define PROGRESS_DATACHECKSUMS_DBS_TOTAL	1
-#define PROGRESS_DATACHECKSUMS_DBS_DONE		2
-#define PROGRESS_DATACHECKSUMS_RELS_TOTAL	3
-#define PROGRESS_DATACHECKSUMS_RELS_DONE	4
-#define PROGRESS_DATACHECKSUMS_BLOCKS_TOTAL	5
-#define PROGRESS_DATACHECKSUMS_BLOCKS_DONE	6
-
-/* Phases of datachecksumsworker operation */
-#define PROGRESS_DATACHECKSUMS_PHASE_ENABLING			0
-#define PROGRESS_DATACHECKSUMS_PHASE_DISABLING			1
-#define PROGRESS_DATACHECKSUMS_PHASE_WAITING_TEMPREL	2
-#define PROGRESS_DATACHECKSUMS_PHASE_WAITING_BARRIER	3
-#define PROGRESS_DATACHECKSUMS_PHASE_DONE				4
-
 #endif
diff --git a/src/include/miscadmin.h b/src/include/miscadmin.h
index 0fc59af02b9..11a7d2f1542 100644
--- a/src/include/miscadmin.h
+++ b/src/include/miscadmin.h
@@ -370,13 +370,6 @@ typedef enum BackendType
 	B_WAL_SUMMARIZER,
 	B_WAL_WRITER,
 
-	/*
-	 * Data checksums processes are dynamic background workers, but they use
-	 * dedicated backend types for pgstat I/O accounting.
-	 */
-	B_DATACHECKSUMSWORKER_LAUNCHER,
-	B_DATACHECKSUMSWORKER_WORKER,
-
 	/*
 	 * Logger is not connected to shared memory and does not have a PGPROC
 	 * entry.
@@ -402,9 +395,6 @@ extern PGDLLIMPORT BackendType MyBackendType;
 #define AmWalSummarizerProcess()	(MyBackendType == B_WAL_SUMMARIZER)
 #define AmWalWriterProcess()		(MyBackendType == B_WAL_WRITER)
 #define AmIoWorkerProcess()			(MyBackendType == B_IO_WORKER)
-#define AmDataChecksumsWorkerProcess() \
-	(MyBackendType == B_DATACHECKSUMSWORKER_LAUNCHER || \
-	 MyBackendType == B_DATACHECKSUMSWORKER_WORKER)
 
 #define AmSpecialWorkerProcess() \
 	(AmAutoVacuumLauncherProcess() || \
diff --git a/src/include/postmaster/proctypelist.h b/src/include/postmaster/proctypelist.h
index 152fde394f4..feac19ba207 100644
--- a/src/include/postmaster/proctypelist.h
+++ b/src/include/postmaster/proctypelist.h
@@ -38,8 +38,6 @@ PG_PROCTYPE(B_BACKEND, "backend", gettext_noop("client backend"), BackendMain, t
 PG_PROCTYPE(B_BG_WORKER, "bgworker", gettext_noop("background worker"), BackgroundWorkerMain, true)
 PG_PROCTYPE(B_BG_WRITER, "bgwriter", gettext_noop("background writer"), BackgroundWriterMain, true)
 PG_PROCTYPE(B_CHECKPOINTER, "checkpointer", gettext_noop("checkpointer"), CheckpointerMain, true)
-PG_PROCTYPE(B_DATACHECKSUMSWORKER_LAUNCHER, "checksums", gettext_noop("datachecksums launcher"), NULL, false)
-PG_PROCTYPE(B_DATACHECKSUMSWORKER_WORKER, "checksums", gettext_noop("datachecksums worker"), NULL, false)
 PG_PROCTYPE(B_DEAD_END_BACKEND, "backend", gettext_noop("dead-end client backend"), BackendMain, true)
 PG_PROCTYPE(B_INVALID, "postmaster", gettext_noop("unrecognized"), NULL, false)
 PG_PROCTYPE(B_IO_WORKER, "ioworker", gettext_noop("io worker"), IoWorkerMain, true)
